/*
   Written by Pieter J. Schoenmakers <tiggr@es.ele.tue.nl>

   Copyright (C) 1996 Pieter J. Schoenmakers.
   All rights reserved.

   This file is part of TOM.  TOM is distributed under the terms of the
   TOM License, a copy of which can be found in the TOM distribution; see
   the file LICENSE.

   $Id: trt_send.S,v 1.2 1996/06/07 16:08:54 tiggr Exp $  */

#include <tom/trt.h>
#include <target.h>

/* return_type
   trt_send (tom_State_c_ref self, selector *_cmd)
   {
     int sel_id = _cmd->sel_id;
     int bucket_idx = sel_id / TRT_BUCKET_SIZE;
     int imp_idx = sel_id % TRT_BUCKET_SIZE;

     jump (self->isa->mdt->b[bucket_idx].m[imp_idx]);
   }
 */

#ifdef AS_LABEL_UNDERSCORES
#define TRT_SEND  _trt_send
#define TRT_SEND_NIL  _trt_send_nil
#define TRT_SEND_SUPER  _trt_send_super
#else
#define TRT_SEND  trt_send
#define TRT_SEND_NIL  trt_send_nil
#define TRT_SEND_SUPER  trt_send_super
#endif

.text
	.align 4
.globl TRT_SEND
	.type	 TRT_SEND,@function
TRT_SEND:
	movl	4(%esp),%eax
	movl	8(%esp),%edx
	movl	(%edx),%ecx
#if defined (DEBUG) || defined (ALWAYS_CHECK_NIL_RECEIVER)
	testl	%eax,%eax
	je	TRT_SEND_NIL
#endif
	movl	(%eax),%eax
	movl	8(%eax),%edx
	movl	%ecx,%eax
	shrl	$4,%eax
	movl	8(%edx,%eax,4),%edx
	movl	%ecx,%eax
	andl	$15,%eax
	movl	(%edx,%eax,4),%eax
	jmp	%eax
.Lfe1:
	.size	 TRT_SEND,.Lfe1-TRT_SEND
	.align 4

/* return_type
   trt_send_super (trt_class *class, tom_State_c_ref self, selector *_cmd)
   {
     int sel_id = _cmd->sel_id;
     int bucket_idx = sel_id / TRT_BUCKET_SIZE;
     int imp_idx = sel_id % TRT_BUCKET_SIZE;

     imp = class->mdt->b[bucket_idx].m[imp_idx];

     r = pop (return-pc);
     pop (class);
     push (return-pc);

     jump imp;
   }
 */

.globl TRT_SEND_SUPER
	.type	 TRT_SEND_SUPER,@function
TRT_SEND_SUPER:
	popl	%eax		/* pop (return_pc)  */
	popl	%edx		/* pop (class) */
	pushl	%eax		/* push (return_pc)  */
	movl	8(%esp),%eax	/* selector */
	movl	(%eax),%eax	/* sid = selector->sel_id */
	movl	8(%edx),%ecx	/* class->mdt */
	movl	%eax,%edx
	shrl	$4,%edx
	movl	8(%ecx,%edx,4),%edx
	andl	$15,%eax
	movl	(%edx,%eax,4),%eax
	jmp	%eax
.Lfe2:
	.size	 TRT_SEND_SUPER,.Lfe2-TRT_SEND_SUPER
