/*
   Written by Pieter J. Schoenmakers <tiggr@es.ele.tue.nl>

   Copyright (C) 1996 Pieter J. Schoenmakers.
   All rights reserved.

   This file is part of TOM.  TOM is distributed under the terms of the
   TOM License, a copy of which can be found in the TOM distribution; see
   the file LICENSE.

   $Id: target.h,v 1.3 1996/06/24 21:35:08 tiggr Exp $  */

#include <setjmp.h>
#include <mach/std_types.h>

/* An integer type which can hold all bits in a pointer.  */
#define POINTER_INT_TYPE  vm_address_t

#define FIRST_RANGE_ADDRESS  (void *) (16 * RANGE_SIZE)

#define TGC_MARK_REGISTERS()  \
  do							\
    {							\
      jmp_buf regs;					\
      int r;						\
							\
      setjmp (regs);					\
							\
      for (r = REG_PROT_START; r < REG_PROT_END; r++)	\
	if (*(char **) &regs[r] >= lowest_range_addr)	\
	  check_for_reference (*(char **) &regs[r]);	\
    } while (0)

#define DLOAD_SYMBOL_PREFIX  "_"

#include <config/default.h>
