<copyright> 
    Written by <a href="mailto:tiggr@es.ele.tue.nl">Pieter J. Schoenmakers</a>

    Copyright (C) 1996 Pieter J. Schoenmakers.
    All rights reserved.

    This file is part of TOM.  TOM is distributed under the terms of the
    TOM License, a copy of which can be found in the TOM distribution; see
    the file LICENSE.

    <id>$Id: TestLex.t,v 1.3 1996/09/02 15:52:56 tiggr Exp $</id>
    </copyright>

implementation class
TestLex: gps.Lexer, TestParseDefines

end;

implementation instance
TestLex
{
  <doc> The next character to digest.  </doc>
  int next;
}

redefine id
  initWithStream InputStream s
	   named String n
{
  next = [s read];

  = [super initWithStream s named n]
}

int
  nextToken
{
  semantics = nil;

  while (next == ' ' || next == '\t')
    next = [stream read];

  if ((next >= 'a' && next <= 'z') || (next >= 'A' && next <= 'Z'))
    {
      MutableByteString s = [MutableByteString new];

      do
	{
	  [s add byte (next)];
	  next = [stream read]
	} while ((next >= 'a' && next <= 'z')
		 || (next >= 'A' && next <= 'Z')
		 || (next >= '0' && next <= '9') || next == '_');

      semantics = Any (s);
      token = IDENTIFIER
    }
  else if (next >= '0' && next <= '9')
    {
      int value;

      do
	{
	  value = 10 * value + next - '0';
	  next = [stream read]
	} while (next >= '0' && next <= '9');

      semantics = Any ([IntNumber with value]);
      token = NUMBER
    }
  else if (next == -1)
    token = 0
  else if (next == '\n')
    {
      current_line++;
      next = [stream read];
      token = [self nextToken]
    }
  else
    {
      token = next;
      next = [stream read]
    };

  = token
}

end;
