<copyright> TOM parser generator main.
    Written by <a href="mailto:tiggr@es.ele.tue.nl">Pieter J. Schoenmakers</a>

    Copyright (C) 1996 Pieter J. Schoenmakers.
    All rights reserved.

    This file is part of TOM.  TOM is distributed under the terms of the
    TOM License, a copy of which can be found in the TOM distribution; see
    the file LICENSE.

    <id>$Id: gp.t,v 1.5 1996/09/02 15:53:05 tiggr Exp $</id>
    </copyright>

implementation class gp: stdio, FileUser
{
  <doc> Control the amount of junk output generated.  </doc>
  static boolean verbose;
}

void
  usage
{
  [[err print ("usage: ", [Runtime program_name],
	       " [-d] [-v] [-o file] file")] nl];

  [Runtime exit 1]
}

int
  main Array arguments
{
  ByteStream out_file = ByteStream (out);
  String in_filename, out_filename;
  int i, n = [arguments length];

  out = [BufferedStream with out];

  for (i = 0; i < n; i++)
    {
      String a = arguments[i];

      if (a[0] == '-')
	{
	  if (["-d" equal a])
	    [Parser set_trace_default YES]
	  else if (["-v" equal a])
	    verbose = YES
	  else if (["-o" equal a])
	    if (i < n - 1)
	      {
		a = arguments[++i];
		if (out_filename != nil)
		  [self usage]
		else
		  out_filename = a
	      }
	    else
	      [self usage]
	  else
	    [self usage]
	}
      else if (!in_filename)
	in_filename = a
      else
	[self usage]
    };

  if (!in_filename)
    [self usage];

  GPLex lex = [[GPLex alloc] initWithStream
	       [BufferedStream with [File open in_filename input: YES]]
			     named in_filename];

  GPParse parse = [[GPParse alloc] init lex];

  [parse grammar];

  if (out_filename != nil)
    out_file = [File open out_filename output: YES flags: NOT_EXIST_CREATE];

  [parse generate out_file];

  if (verbose)
    [[err print (in_filename, ": ", [lex current_line], " lines")] nl];

  = [parse num_errors]
}

end;

implementation instance gp end;
