<copyright> GP Lexer skeleton.
    Written by <a href="mailto:tiggr@es.ele.tue.nl">Pieter J. Schoenmakers</a>

    Copyright &copy; 1996 Pieter J. Schoenmakers.
    All rights reserved.

    This file is part of TOM.  TOM is distributed under the terms of the
    TOM License, a copy of which can be found in the TOM distribution; see
    the file LICENSE.

    <id>$Id: Lexer.t,v 1.6 1996/09/06 16:16:57 tiggr Exp $</id>
    </copyright>

implementation class
Lexer: State, Conditions

end;

implementation instance
Lexer
{
  <doc> The input stream from which we're reading.  </doc>
  InputStream stream;

  <doc> The parser which we're feeding.  </doc>
  public Parser parser;

  <doc> The current line number.  </doc>
  public int current_line;

  <doc> The current token.  </doc>
  public int token;

  <doc> The semantics content of the current token.  </doc>
  public Any semantics;

  <doc> The filename, at least what we think it is.  </doc>
  public String filename;
}

<doc> Designated initializer.  </doc>
id
  initWithStream InputStream s
	   named String f
{
  (current_line, filename, stream) = (1, f, s);

  = self
}

<doc> Read and return another token from the input.  </doc>
deferred int
  nextToken;

void
  set_parser Parser p
{
  if (parser != nil)
    [[Condition for self class program-condition
		message "re-assign parser"] signal];
  parser = p
}

end;
