/*
   Written by Pieter J. Schoenmakers <tiggr@es.ele.tue.nl>

   Copyright (C) 1996 Pieter J. Schoenmakers.
   All rights reserved.

   This file is part of TOM.  TOM is distributed under the terms of the
   TOM License, a copy of which can be found in the TOM distribution; see
   the file LICENSE.

   $Id: LTISelector.h,v 1.4 1996/02/26 00:23:03 tiggr Exp $  */

#import "lti.h"

@interface LTISelector: LTTTop
{
  /* Our structural counterpart.  */
  LTTSelector *structure;

  /* Methods implementing this message.  */
  TLVector *methods;

  /* Our unique id.  */
  int identity;
}

+(LTISelector *) selectorIdentified: (int) identity;

/* Return the number of allocated selectors.  For all selectors, 0 <=
   identity < numSelectors.  */
+(int) numSelectors;

/* Return an enumerator on all selectors semantics.  */
+(id <TLEnumerator>) selectors;

-(void) addMethod: (LTIMethod *) m;

-(int) identity;

-(id <TLEnumerator>) methods;

-(LTTSelector *) structure;

#ifdef LTISELECTOR_DECLARE_PRIVATE_METHODS

-initWithSelector: (LTTSelector *) sel;

#endif

@end
