/*
   Written by Pieter J. Schoenmakers <tiggr@es.ele.tue.nl>

   Copyright (C) 1996 Pieter J. Schoenmakers.
   All rights reserved.

   This file is part of TOM.  TOM is distributed under the terms of the
   TOM License, a copy of which can be found in the TOM distribution; see
   the file LICENSE.

   $Id: LTIStringCST.m,v 1.3 1996/09/05 15:01:55 tiggr Exp $  */

#define LTISTRINGCST_DECLARE_PRIVATE_METHODS
#import "LTIStringCST.h"

static TLVector *all_strings;

static TLDictionary *strings;

@implementation LTTStringCST (Semantics)

+(id) semanticsForString: (LTTStringCST *) s
{
  return [[LTIStringCST gcAlloc] initWithStructure: s];
} /* +semanticsForString: */

@end

@implementation LTIStringCST

+(id <TLEnumerator>) allStrings
{
  return [all_strings enumerator];
} /* +allStrings */

+initialize
{
  if (!all_strings)
    {
      all_strings = [TLVector vector];
      [all_strings gcLock];
      strings = [TLDictionary dictionary];
      [strings gcLock];
    }
  return self;
} /* +initialize */

+(LTIStringCST *) stringForString: (id <TLString>) string
{
  return [strings objectForKey: string];
} /* +stringForString: */

+(id <TLEnumerator>) strings
{
  return [strings valueEnumerator];
} /* +strings */

+(void) sufferAmnesia
{
  strings = nil;
  all_strings = nil;
  [self initialize];
}

-(LTTStringCST *) structure
{
  return structure;
} /* -structure */

-(void) gcReference
{
  MARK (structure);

  [super gcReference];
} /* -gcReference */

-initWithStructure: (LTTStringCST *) str
{
  if (![super init])
    return nil;

  structure = str;

  [all_strings addElement: self];
  if (![strings objectForKey: [structure string]])
    [strings setObject: self forKey: [structure string]];

  return self;
} /* -initWithStructure: */

-(void) print: (id <TLMutableStream>) stream quoted: (BOOL) qp
{
  formac (stream, @"#<%s %p %@ %@>", class_get_class_name (isa), self,
	  [structure name], [structure string]);
}

@end
