/*
   Written by Pieter J. Schoenmakers <tiggr@es.ele.tue.nl>

   Copyright (C) 1996 Pieter J. Schoenmakers.
   All rights reserved.

   This file is part of TOM.  TOM is distributed under the terms of the
   TOM License, a copy of which can be found in the TOM distribution; see
   the file LICENSE.

   $Id: LTTFile.h,v 1.3 1996/03/04 17:51:20 tiggr Exp $  */

#import "LTTEntity.h"

@class LTTFileItem, LTTUnit;

@interface LTTFile: LTTEntity
{
  /* The unit to which we belong.  */
  LTTUnit *unit;

  /* Extensions defined in/by us.  */
  TLVector *items;

  /* Whether this file has been loaded, or is being loaded.  */
  unsigned int loaded_int: 1, loaded_imp: 1;
}

+(LTTFile *) fileWithName: (TLString *) n unit: (LTTUnit *) u;

-(id) initWithName: (TLString *) n unit: (LTTUnit *) u;

-(void) addItem: (LTTFileItem *) item;

-(TLVector *) items;

-(BOOL) loadedInterface;
-(void) setLoadedInterface;

-(BOOL) loadedImplementation;
-(void) setLoadedImplementation;

-(LTTUnit *) unit;

@end
