/*
   Written by Pieter J. Schoenmakers <tiggr@es.ele.tue.nl>

   Copyright (C) 1996 Pieter J. Schoenmakers.
   All rights reserved.

   This file is part of TOM.  TOM is distributed under the terms of the
   TOM License, a copy of which can be found in the TOM distribution; see
   the file LICENSE.

   $Id: LTTFile.m,v 1.6 1996/05/01 11:19:45 tiggr Exp $  */

#import "ltt.h"

@implementation LTTFile

+(LTTFile *) fileWithName: (TLString *) n unit: (LTTUnit *) u
{
  return [[self gcAlloc] initWithName: n unit: u];
} /* +fileWithName:unit: */

-(void) addItem: (LTTFileItem *) item
{
  [items addElement: item];
} /* -addItem: */

-(TLVector *) items
{
  return items;
} /* -items */

-(void) gcReference
{
  MARK (unit);
  MARK (items);

  [super gcReference];
} /* -gcReference */

-(id) initWithName: (TLString *) n unit: (LTTUnit *) u
{
  [super initWithName: [LTTName nameWithInternal: n external: n]];

  items = [TLVector vector];
  unit = u;

  return self;
} /* -initWithName:unit: */

-(BOOL) loadedImplementation
{
  return loaded_imp;
} /* -loadedImplementation */

-(BOOL) loadedInterface
{
  return loaded_int;
} /* -loadedInterface */

-(void) setLoadedImplementation
{
  loaded_imp = YES;
} /* -setLoadedImplementation */

-(void) setLoadedInterface
{
  loaded_int = YES;
} /* -setLoadedInterface */

-(LTTUnit *) unit
{
  return unit;
} /* -unit */

@end
