/*
   Written by Pieter J. Schoenmakers <tiggr@es.ele.tue.nl>

   Copyright (C) 1996 Pieter J. Schoenmakers.
   All rights reserved.

   This file is part of TOM.  TOM is distributed under the terms of the
   TOM License, a copy of which can be found in the TOM distribution; see
   the file LICENSE.

   $Id: LTTStringCST.m,v 1.2 1996/06/26 14:40:59 tiggr Exp $  */

#define LTTSTRINGCST_DECLARE_PRIVATE_METHODS
#import "LTTStringCST.h"
#import "ltt.h"

@implementation LTTStringCST

+(LTTStringCST *) stringWithString: (id <TLString>) str name: (id <TLString>) n
{
  LTTStringCST *s = [[self gcAlloc] initWithString: str name: n];

  [s setSemantics: [self semanticsForString: s]];

  return s;
} /* +stringWithString: */

-(void) gcReference
{
  MARK (string);

  [super gcReference];
} /* -gcReference */

-(id) initWithString: (TLString *) str name: (id <TLString>) n;
{
  if (![super initWithName: n])
    return nil;

  string = str;

  return self;
} /* -initWithString: */

-(id <TLString>) outputDefinitionName
{
  return formac (nil, @"%@%@", TO_STRING_DST_PREFIX, name);
}

-(id <TLString>) outputReferenceName
{
  return formac (nil, @"%@%@", TO_STRING_CST_PREFIX, name);
}

-(id <TLString>) string
{
  return string;
} /* -string */

@end
