/*
   Written by Pieter J. Schoenmakers <tiggr@es.ele.tue.nl>

   Copyright (C) 1996 Pieter J. Schoenmakers.
   All rights reserved.

   This file is part of TOM.  TOM is distributed under the terms of the
   TOM License, a copy of which can be found in the TOM distribution; see
   the file LICENSE.

   $Id: OTMAlias.m,v 1.1 1996/04/15 16:19:21 tiggr Exp $  */

#define OTMALIAS_DECLARE_PRIVATE_METHODS
#import "OTMAlias.h"
#import "OTMCustomMethod.h"
#import "OTMExtension.h"
#import "OTMObjectVar.h"
#import "OTMType.h"
#import "LTTPatches.h"
#import "global.h"

@implementation OTMAlias

+(OTMAlias *) aliasWithExtension: (OTMExtension *) e
			variable: (OTMObjectVar *) orig
			    type: (OTMType *) t
		      qualifiers: (otm_qualifiers) q
{
  return [[self gcAlloc] initWithExtension: e variable: orig
			 type: t qualifiers: q];
} /* +aliasWithExtension:variable:type:qualifiers: */

-(id) elaborate
{
  value = implicit_cast (value, type);

  return [super elaborate];
}

-(id) initWithExtension: (OTMExtension *) e
	       variable: (OTMObjectVar *) orig
		   type: (OTMType *) t
	     qualifiers: (otm_qualifiers) q
{
  if (![super initWithExtension: e name: [orig name] value: orig])
    return nil;

  [self setQualifiers: q];
  type = t;

  return self;
} /* -initWithExtension:variable:qualifiers: */

@end
