/*
   Written by Pieter J. Schoenmakers <tiggr@es.ele.tue.nl>

   Copyright (C) 1996 Pieter J. Schoenmakers.
   All rights reserved.

   This file is part of TOM.  TOM is distributed under the terms of the
   TOM License, a copy of which can be found in the TOM distribution; see
   the file LICENSE.

   $Id: OTMCast.m,v 1.7 1996/05/10 18:04:56 tiggr Exp $  */

#import "OTMCast.h"
#import "OTMType.h"

@implementation OTMCast

+(OTMCast *) castWithExpr: (OTMExpr *) e type: (OTMType *) t
{
  return [[self gcAlloc] initWithExpr: e type: t];
} /* +castWithExpr:type: */

-(id) elaborate
{
  expr = [expr elaborate];

  return self;
} /* -elaborate */

-(void) gcReference
{
  MARK (expr);

  [super gcReference];
} /* -gcReference */

-initWithExpr: (OTMExpr *) e type: (OTMType *) t
{
  if (![super initWithType: t])
    return nil;

  expr = e;

  return self;
} /* -initWithExpr:type: */

-(id) precompile
{
  expr = [expr precompile];

  return [super precompile];
} /* -precompile: */

-(TLCons *) resolveWithExpected: (TLCons *) expected
		    convertible: (OTMType *) to
			context: (OTMType *) cxt
			indices: (int *) indices
			  index: (int) index
{
  if (![expr type])
    {
      expr = resolve_expr (expr, nil, type, cxt);

      return CONS (expected
		   ? types_element_of (type, expected, cxt, indices, index, 1)
		   : type, nil);
    }

  return [super resolveWithExpected: expected convertible: to context: cxt
		indices: indices index: index];
}

-(id <TLString>) result
{
  return formac (nil, @"((%@) (%@))", [type outputTypeName], [expr result]);
} /* -result */

@end
