/*
   Written by Pieter J. Schoenmakers <tiggr@es.ele.tue.nl>

   Copyright (C) 1996 Pieter J. Schoenmakers.
   All rights reserved.

   This file is part of TOM.  TOM is distributed under the terms of the
   TOM License, a copy of which can be found in the TOM distribution; see
   the file LICENSE.

   $Id: OTMExpr.m,v 1.23 1996/05/10 18:05:15 tiggr Exp $  */

#define OTMEXPR_DECLARE_PRIVATE_METHODS
#import "OTMExpr.h"
#import "OTMBasic.h"
#import "OTMType.h"

@implementation OTMExpr

-(void) compile
{
  /* Nothing to do.  */
} /* -compile: */

-(void) compileAssignment: (OTMExpr *) rhs
{
  if (self != any_type_expr)
    error_for (self, @"invalid lhs (should have been caught earlier)");
} /* -compileAssignment: */

-(void) compileAssignmentToTuple: (OTMTuple *) lhs
{
  error_for (self, @"invalid rhs (should have been caught earlier)");
} /* -compileAssignmentToTuple: */

-(int) flatElementCount
{
  return type == basic_type[BT_VOID] ? 0 : 1;
}

-(void) gcReference
{
  MARK (type);

  [super gcReference];
} /* -gcReference */

-(id) initWithType: (OTMType *) t
{
  if (![super init])
    return nil;

  type = (id) t;

  return self;
} /* -initWithType: */

-(BOOL) isTuple
{
  return NO;
} /* -isTuple */

-(OTMExpr *) lhsInvalid
{
  return self == any_type_expr ? nil : self;
} /* -lhsInvalid */

-(id <TLString>) name
{
  return @"*** otmexpr unimplemented name ***";
} /* -name */

-(id) precompile
{
  type = [type precompile];

  return self;
} /* -precompile: */

-(TLCons *) resolveWithExpected: (TLCons *) expected
		    convertible: (OTMType *) to
			context: (OTMType *) cxt
			indices: (int *) indices
			  index: (int) index
{
  return default_resolve_expr (type, expected, to, cxt, indices, index);
}

-(void) setType: (id) t
{
  ASGN_IVAR (type, t);
} /* -setType: */

-(OTMType *) type
{
  return (id) type;
} /* -type */

@end
