/*
   Written by Pieter J. Schoenmakers <tiggr@es.ele.tue.nl>

   Copyright (C) 1996 Pieter J. Schoenmakers.
   All rights reserved.

   This file is part of TOM.  TOM is distributed under the terms of the
   TOM License, a copy of which can be found in the TOM distribution; see
   the file LICENSE.

   $Id: OTMITE.m,v 1.10 1996/04/12 16:50:56 tiggr Exp $  */

#define OTMITE_DECLARE_PRIVATE_METHODS
#import "OTMITE.h"
#import "OTMBasic.h"
#import "OTMCompound.h"
#import "global.h"

@implementation OTMITE

+(OTMITE *) iteWithCondition: (OTMExpr *) c
{
  return [[self gcAlloc] initWithCondition: c];
} /* +iteWithCondition: */

-(void) compile
{
  [ip compile];

  formac (of, @"%@if (%@)", nl (), [ip result]);

  indent_level++;
  if (tp)
    [tp compile];
  else
    formac (of, @"%@;", nl ());
  indent_level--;

  if (ep)
    {
      formac (of, @"%@else", nl ());
      indent_level++;
      [ep compile];
      indent_level--;
    }
} /* -compile */

-(void) gcReference
{
  MARK (ip);
  MARK (tp);
  MARK (ep);

  [super gcReference];
} /* -gcReference */

-initWithCondition: (OTMExpr *) c
{
  [super init];

  ip = c;

  return self;
} /* -initWithCondition: */

-(id) precompile
{
  ip = [[ip elaborate] precompile];
  tp = [tp precompile];
  ep = [ep precompile];

  return self;
} /* -precompile */

-(void) setThen: (OTMCompound *) t
{
  ASGN_IVAR (tp, t);
} /* -setThen: */

-(void) setElse: (OTMCompound *) e
{
  ASGN_IVAR (ep, e);
} /* -setElse: */

@end
