/*
   Written by Pieter J. Schoenmakers <tiggr@es.ele.tue.nl>

   Copyright (C) 1996 Pieter J. Schoenmakers.
   All rights reserved.

   This file is part of TOM.  TOM is distributed under the terms of the
   TOM License, a copy of which can be found in the TOM distribution; see
   the file LICENSE.

   $Id: OTMIdentifier.m,v 1.1 1996/05/09 16:58:21 tiggr Exp $  */

#import "OTMIdentifier.h"
#import "OTMMeta.h"

int num_identifiers;

@implementation OTMIdentifier

+gcAlloc
{
  num_identifiers++;
  return [super gcAlloc];
}

-(id) resolveInContext: (OTMMeta *) current
{
  id r = [current searchEntityNamed: name
	  supers: YES class: YES variables: YES constants: YES];

  num_identifiers--;

  if (r)
    return r;

  error_for (self, @"undeclared variable `%@'", name);
  return self;
}

@end
