/*
   Written by Pieter J. Schoenmakers <tiggr@es.ele.tue.nl>

   Copyright (C) 1996 Pieter J. Schoenmakers.
   All rights reserved.

   This file is part of TOM.  TOM is distributed under the terms of the
   TOM License, a copy of which can be found in the TOM distribution; see
   the file LICENSE.

   $Id: OTMMetaRef.m,v 1.2 1996/03/19 13:19:31 tiggr Exp $  */

#import "OTMMetaRef.h"
#import "OTMMeta.h"

@implementation OTMMetaRef

+(OTMMetaRef *) metaRefWithMeta: (OTMMeta *) m
{
  return [[self gcAlloc] initWithMeta: m];
} /* +metaRefWithMeta: */

-(void) gcReference
{
  MARK (meta);

  [super gcReference];
} /* -gcReference */

-initWithMeta: (OTMMeta *) m
{
  if (![super initWithType: (id) m])
    return nil;

  meta = m;

  return self;
} /* -initWithMeta: */

-(id) outputReference
{
  return [[meta structure] referenceName];
} /* -outputReference */

-(id) precompile
{
  if (![self declaredp])
    {
      [self setDeclared: YES];

      meta = [meta precompile];
      formac (of, @"extern %@ *%@;\n", [meta outputTypeName],
	      [self outputReference]);
    }

  return self;
} /* -precompile: */

-(id <TLString>) result
{
  return [self outputReference];
} /* -result */

@end
