/*
   Written by Pieter J. Schoenmakers <tiggr@es.ele.tue.nl>

   Copyright (C) 1996 Pieter J. Schoenmakers.
   All rights reserved.

   This file is part of TOM.  TOM is distributed under the terms of the
   TOM License, a copy of which can be found in the TOM distribution; see
   the file LICENSE.

   $Id: OTMNumberCST.m,v 1.2 1996/04/08 16:27:46 tiggr Exp $  */

#define OTMNUMBERCST_DECLARE_PRIVATE_METHODS
#import "OTMNumberCST.h"

@implementation OTMNumberCST

+(OTMNumberCST *) numberWithValue: (id <TLString>) v type: (OTMType *) t
{
  return [[self gcAlloc] initWithValue: v type: t];
} /* +numberWithValue:type: */

-(void) description: (id <TLMutableStream>) stream
{
  [super description: stream];

  formac (stream, @" %@", value);
} /* -description: */

-(void) gcReference
{
  MARK (value);

  [super gcReference];
} /* -gcReference */

-(id) initWithValue: (id) v type: (OTMType *) t
{
  if (![super initWithType: t])
    return nil;

  value = v;

  return self;
} /* -initWithValue:type: */

-(id <TLString>) result
{
  return value;
} /* -result */

-(id <TLString>) value
{
  return value;
} /* -value */

@end
