/*
   Written by Pieter J. Schoenmakers <tiggr@es.ele.tue.nl>

   Copyright (C) 1996 Pieter J. Schoenmakers.
   All rights reserved.

   This file is part of TOM.  TOM is distributed under the terms of the
   TOM License, a copy of which can be found in the TOM distribution; see
   the file LICENSE.

   $Id: OTMStringCST.m,v 1.4 1996/09/05 14:59:31 tiggr Exp $  */

#define OTMSTRINGCST_DECLARE_PRIVATE_METHODS
#import "OTMStringCST.h"
#import "OTMType.h"

@implementation LTTStringCST (Semantics)

+(id) semanticsForString: (LTTStringCST *) s
{
  return [[OTMStringCST gcAlloc] initWithStructure: s];
} /* +semanticsForString: */

@end

@implementation OTMStringCST

-(BOOL) constantp
{
  return YES;
} /* constantp */

-initWithStructure: (LTTStringCST *) str
{
  if (![super initWithType: (OTMType *) tom_string_instance])
    return nil;

  structure = str;

  return self;
} /* -initWithStructure: */

-outputReference
{
  return [structure outputReferenceName];
} /* -outputReference */

-(id) precompile
{
  if (![self declarationOutputp])
    {
      [self setDeclarationOutputP: YES];

      [used_strings setObject: structure forKey: [structure string]];

      [super precompile];

      formac (of, @"extern %@ %@;\n", [type outputTypeName],
	      [structure outputReferenceName]);
    }

  return self;
} /* -precompile */

-(id <TLString>) result
{
  return [self outputReference];
} /* -result */

-(LTTStringCST *) structure
{
  return structure;
} /* -structure */

@end
