/*
   Written by Pieter J. Schoenmakers <tiggr@es.ele.tue.nl>

   Copyright (C) 1996 Pieter J. Schoenmakers.
   All rights reserved.

   This file is part of TOM.  TOM is distributed under the terms of the
   TOM License, a copy of which can be found in the TOM distribution; see
   the file LICENSE.

   $Id: OTMType.m,v 1.21 1996/08/27 10:05:56 tiggr Exp $  */

#import "OTMType.h"

@implementation OTMType

-(BOOL) allowedTypeForArgumentRedeclaration: (OTMType *) t
				 inSubclass: (BOOL) subclass_p
{
  return NO;
} /* -allowedTypeForArgumentRedeclaration:inSubclass: */

-(void) compileDeclaration
{
} /* -compileDeclaration */

-(int) flatElementCount
{
  return 1;
} /* -flatElementCount */

-(id <TLString>) flatFrobnicatedName
{
  return [self frobnicatedName];
} /* -flatFrobnicatedName */

-(BOOL) isFullyDefinedType
{
  return YES;
} /* -isFullyDefinedType */

-(BOOL) isObjectType
{
  return NO;
} /* -isObjectType */

-(BOOL) isTuple
{
  return NO;
} /* -isTuple */

-(BOOL) matches: (OTMType *) t
{
  return NO;
} /* -matches: */

-(BOOL) matchesExactly: (OTMType *) t
{
  return self == t;
}

-(int) minimumAlignment
{
  return 0;
}

-(id <TLString>) outputCastName
{
  return [self outputTypeName];
} /* -outputCastName */

-(id) precompile
{
  return self;
} /* -precompile */

-(OTMType *) tupleSingleElement
{
  return self;
} /* -tupleSingleElement */

-(OTMType *) tupleFirstFlatElement
{
  return self;
} /* -tupleFirstFlatElement */

-(OTMType *) typeAt: (int) index in: (int *) indices
{
  return index < 0 ? self : nil;
}

-(id <TLString>) typeInfo
{
  ABORT ();
} /* typeInfo */

-(BOOL) validCastTo: (OTMType *) type
{
  return type == self;
} /* -validCastTo: */

@end
