/*
   Written by Pieter J. Schoenmakers <tiggr@es.ele.tue.nl>

   Copyright (C) 1996 Pieter J. Schoenmakers.
   All rights reserved.

   This file is part of TOM.  TOM is distributed under the terms of the
   TOM License, a copy of which can be found in the TOM distribution; see
   the file LICENSE.

   $Id: OTMUnwind.m,v 1.1 1996/05/07 15:03:19 tiggr Exp $  */

#define OTMUNWIND_DECLARE_PRIVATE_METHODS
#import "OTMUnwind.h"
#import "OTMBasic.h"

@implementation OTMUnwind

+(OTMUnwind *) unwindWithProtection: (OTMExpr *) t container: (OTMCompound *) c
{
  return [[self gcAlloc] initWithProtection: t container: c];
}

-(void) compileCondition: (BOOL) end_not_start
{
  if (!end_not_start)
    {
      formac (of, @"%@/* BEGIN START OF UNWIND  */", nl ());
      formac (of, @"%@void%@_unwind (void)%@{", nl (), nl (), nl ());
      indent_level++;
      [protection compile];
      indent_level--;
      formac (of, @"%@}%@struct trt_unwind _unwind_info;", nl (), nl ());
      formac (of, @"%@_unwind_info.c.kind = TRT_CONDITION_KIND_UNWIND;", nl ());
      formac (of, @"%@_unwind_info.protect = _unwind;", nl ());

      formac (of, @"%@trt_register (&_unwind_info.c);", nl ());
      formac (of, @"%@/* FINISH START OF UNWIND  */\n", nl ());
    }
  else
    {
      formac (of, @"\n%@/* BEGIN END OF UNWIND  */", nl ());
      formac (of, @"%@trt_unwind (&_unwind_info.c);", nl ());
      formac (of, @"%@_unwind ();", nl ());
      formac (of, @"%@/* FINISH END OF UNWIND  */", nl ());
    }
} /* -compileCondition: */

-(void) gcReference
{
  MARK (protection);

  [super gcReference];
} /* -gcReference */

-(id) initWithProtection: (OTMExpr *) p container: (OTMCompound *) c;
{
  [super initWithContainer: c];

  protection = p;

  return self;
}

@end
