/* TOM test class.  -*- objc -*-

   $Id: test.t,v 1.44 1996/09/06 16:40:33 tiggr Exp $  */

implementation class Test: State, Conditions, stdio

void
  test1 Array arguments
{
  int b = 1, a;

  catch (self)
      unwind ({
		[[out print "unwinding"] nl];
		b = 2
	      })
        bind (
	      /* For a file error, make the file object return nil (or any
		 other such value indicating failure to the regular
		 caller).  */
	      (file-error, nil);

	      /* Ignore any warnings (by returning the condition we
		 caught).  */
	      (warning, condition);

	      /* For other errors, exit nonlocally.  */
	      (error,
	       {
		 [[out print "error caught"] nl];
		 [self throw void];
		 nil
	       }))
	  {
	    a = 23;
	    [[self alloc] test1];
	    void
	  };

  MutableByteString s1 = MutableByteString ([[[[MutableByteString alloc]
					       print "a = "] print a] nl]);
  MutableByteString s2 = MutableByteString ([[[[MutableByteString alloc]
					       print "b = "] print b] nl]);

  [[out print [Cons cons s1 : [Cons cons s2]]] nl];

  [Conditions set_unhandled_condition_handler self];

  int i = [self perform selector ("i_intValue")]
}

void
  dumpRangeSet IntegerRangeSet s
{
  Enumerator e = [s enumerator];
  boolean b;
  int i;

  while ({(b, i) = [e next]; b})
    [out print (' ', i)];

  [out nl]
}

void
  test2 Array arguments
{
  IntegerRangeSet s = [IntegerRangeSet alloc];

  [[out print s] nl];
  [self dumpRangeSet s];

  [s add 0];
  [[out print s] nl];
  [self dumpRangeSet s];

  [s add 2];
  [[out print s] nl];
  [self dumpRangeSet s];

  [s add 3];
  [[out print s] nl];
  [self dumpRangeSet s];

  [s add -2];
  [[out print s] nl];
  [self dumpRangeSet s];

  [s add -3];
  [[out print s] nl];
  [self dumpRangeSet s];

  [s add 1];
  [[out print s] nl];
  [self dumpRangeSet s];

  [s add -1];
  [[out print s] nl];
  [self dumpRangeSet s];

  [s remove 4];
  [[out print s] nl];
  [self dumpRangeSet s];

  [s remove 3];
  [[out print s] nl];
  [self dumpRangeSet s];

  [s remove -3];
  [[out print s] nl];
  [self dumpRangeSet s];

  [s remove 1];
  [[out print s] nl];
  [self dumpRangeSet s];

  [s remove -1];
  [[out print s] nl];
  [self dumpRangeSet s];

  [s remove 0];
  [[out print s] nl];
  [self dumpRangeSet s];

  [s shiftFrom -100];
  [[out print s] nl];
  [self dumpRangeSet s];

  [s shiftFrom 0];
  [[out print s] nl];
  [self dumpRangeSet s];

  [[out print [s nextNonPresent -100]] nl];

  [[out print [s nextNonPresent -2]] nl];

  [[out print [s nextNonPresent -1]] nl];

  [[out print [s nextNonPresent 0]] nl];

  [[out print [s nextNonPresent 1]] nl];

  [[out print [s nextNonPresent 2]] nl];

  [[out print [s previousNonPresent -100]] nl];

  [[out print [s previousNonPresent -2]] nl];

  [[out print [s previousNonPresent -1]] nl];

  [[out print [s previousNonPresent 0]] nl];

  [[out print [s previousNonPresent 1]] nl];

  [[out print [s previousNonPresent 2]] nl];

  0
}

void
  test3 Array arguments
{
  int i, n = [arguments length];

  out = [BufferedStream with out];

  for (i = 0; i < n; i++)
    {
      ByteString s = arguments[i];
      int value;
      boolean b;
      int l;

      (value, b, l) = [s integerValue (0, -1)];

      [[out print (s, ": (", value, ", ", b, ", ", l, ")")] nl];

      [out print (s, ": ")];
      [[out print value base: 8] nl];
      [[out print value base: 10] nl];
      [[out print value base: 16] nl];
      [[out print value base: 36] nl]
    };

  [out flushOutput]
}

void
  test4 Array arguments
{
  String name = "d/d.so";

  if (catch (self)
        bind ((error, {
			[[err print (name, ": load failed")] nl];
			[self throw void];
			nil
		      }))
	  {
	    [Bundle load name];
	    TRUE
	  })
    {
      int i = [self perform selector ("i_helloWorld")]
    }
}

void
  test5 Array arguments
{
  int i, n = [arguments length];

  if (!n)
    [[err print ("usage: ", [Runtime program_name], " string ...")] nl]
  else
    {
      for (i = 0; i < n; i++)
	{
	  [[out print [arguments[i] stringByDecoding "8859-1"]] nl]
	}
    }
}

void
  test6 Array arguments
{
  int i, n = [arguments length];

  if (!n)
    [[out print [self extensionNamed nil]] nl]
  else
    for (i = 0; i < n; i++)
      {
	String s = arguments[i];
	instance (id) t = [self new];
	Extension x = [t extensionNamed s inherited: YES];

	[[out print (s, ": ", x)] nl];

	Any a = [x perform selector ("r_replacementForPortCoder_r") on t
		   with nil]
      }
}

int
  main Array arguments
{
  [self test6 arguments];

  = 0
}

end;

implementation instance Test

int
  test1
{
  int i;

  for (i = 0; i < 100000; i++)
    [ObjectArray withEnumerable [ObjectArray with ("a")]];

  // [[Condition for self class error message nil] signal];

  = 0
}

int
  helloWorld
{
  // This method (declaration) is needed for the perform of its selector
  // above.
  // Fri Sep  6 18:21:21 1996, tiggr@cobra.es.ele.tue.nl
  void
}

end;

// The following are all bugs which need to be fixed.
<0>
void foo {int work, i; if ((work, i) == (work, i)) 0}

// This doesn't issue an error even though it should (the `return 0' does
// cause the proper error).
void foo {= 0}

</0>
