<copyright> ByteArray class.
    Written by <a href="mailto:tiggr@es.ele.tue.nl">Pieter J. Schoenmakers</a>

    Copyright &copy; 1995, 1996 Pieter J. Schoenmakers.
    All rights reserved.

    This file is part of TOM.  TOM is distributed under the terms of the
    TOM License, a copy of which can be found in the TOM distribution; see
    the file LICENSE.

    <id>$Id: ByteArray.t,v 1.13 1996/05/28 16:41:11 tiggr Exp $</id>
    </copyright>

<doc> Like the {CharArray}, the {ByteArray} is a particular kind of
    {Array}, which is here for abstraction purposes, but which is never
    actually used, since the {ByteString} holds the same kind of state,
    but provides much more functionality.  </doc>
implementation class
ByteArray: Array

end;

implementation instance
ByteArray

protected extern id
  initWithEnumerator Enumerator e;

Any
  at int index
{
  byte b = self[index];

  = Any ([ByteNumber with b])
}

redefine extern byte
  at int index;

redefine extern char
  at int index;

redefine int
  at int index
{
  byte c = self[index];

  = c
}

redefine long
  at int index
{
  byte c = self[index];

  = c
}

redefine float
  at int index
{
  byte c = self[index];

  = float (c)
}

redefine double
  at int index
{
  byte c = self[index];

  = double (c)
}

redefine extern int
  hash;

extern  (pointer, int)
  pointerToElements (int, int) (start, len);

int
  writeRange (int, int) (start, len)
        into MutableByteArray destination
	  at int position
{
  = [destination readRange (start, len) fromByteArray self to position]
}

end;
