<copyright> CharArray class.
    Written by <a href="mailto:tiggr@es.ele.tue.nl">Pieter J. Schoenmakers</a>

    Copyright &copy; 1995, 1996 Pieter J. Schoenmakers.
    All rights reserved.

    This file is part of TOM.  TOM is distributed under the terms of the
    TOM License, a copy of which can be found in the TOM distribution; see
    the file LICENSE.

    <id>$Id: CharArray.t,v 1.19 1996/05/28 16:41:17 tiggr Exp $</id>
    </copyright>

<doc> Like the {ByteArray}, the {CharArray} is a particular kind of
    {Array}, which is here for abstraction purposes, but which is never
    actually used, since the {CharString} holds the same kind of state,
    but provides much more functionality.  </doc>
implementation class
CharArray: Array

end;

implementation instance
CharArray

Any
  at int index
{
  byte b = self[index];

  = Any ([ByteNumber with b])
}

redefine extern byte
  at int index;

<doc> Return the char value at {index}.  This is the elementary retrieval
    method for character arrays.  </doc>
redefine extern char
  at int index;

redefine int
  at int index
{
  char c = self[index];

  = c
}

redefine long
  at int index
{
  char c = self[index];

  = c
}

redefine float
  at int index
{
  char c = self[index];

  = float (c)
}

redefine double
  at int index
{
  char c = self[index];

  = double (c)
}

protected extern id
  initWithEnumerator Enumerator e;

extern  (pointer, int)
  pointerToElements (int, int) (start, len);

end;
