<copyright> Singly linked lists.
    Written by <a href="mailto:tiggr@es.ele.tue.nl">Pieter J. Schoenmakers</a>

    Copyright &copy; 1995, 1996 Pieter J. Schoenmakers.
    All rights reserved.

    This file is part of TOM.  TOM is distributed under the terms of the
    TOM License, a copy of which can be found in the TOM distribution; see
    the file LICENSE.

    <id>$Id: Cons.t,v 1.1 1996/05/20 12:56:49 tiggr Exp $</id>  </copyright>

implementation class
Cons: State

<doc> Return a newly allocated instance with the {a} and {d} as the {car}
    and {cdr}, respectively.  </doc>
instance (id)
  with (All, All) (a, d)
{
  = [[self alloc] init (a, d)]
}

<doc> Return a newly allocated instance with the {a} and {d} as the {car}
    and {cdr}, respectively.  The cdr {d} defaults to {nil}.  </doc>
instance (id)
  cons All a
     : All d = nil
{
  = [[self alloc] init (a, d)]
}

end;

implementation instance
Cons
{
  <doc> The element contained in this {Cons} cell, and the remainder of
      the list.  </doc>
  public mutable Any car, cdr;
}

<doc> Designated initializer.  </doc>
protected id
  init (All, All) (a, d)
{
  (car, cdr) = (Any (a), Any (d));

  = self
}

<doc> Return {YES}.  </doc>
redefine boolean
  consp
{
  = TRUE
}

<doc> Return the {(car, cdr)} in a tuple.  </doc>
(Any, Any)
  decons
{
  = (car, cdr)
}

<doc> Output the list, of which the receiving {Cons} cell is the start, to
    the stream {s}.  </doc>
redefine OutputStream
  write OutputStream s
{
  s = [["(" write s] print car];

  if (cdr == nil)
    s = [")" write s]
  else
    s = [cdr writeListElement s];

  = s
}

<doc> Continue outputing the list, of which the receiving {Cons} cell is
    an element and not the head, to the stream {s}.  </doc>
redefine OutputStream
  writeListElement OutputStream s
{
  s = [[" " write s] print car];

  if (cdr == nil)
    s = [")" write s]
  else
    s = [cdr writeListElement s];

  = s
}

end;

implementation class
All extension Cons

end;

implementation instance
All extension Cons

<doc> Return {NO}.  </doc>
boolean
  consp
{
  = FALSE
}

<doc> Finish outputing the list, of which the receiving object is the
    tail, to the stream {s}.  </doc>
OutputStream
  writeListElement OutputStream s
{
  = [")" write [self write [" . " write s]]]
}

end;
