<copyright> Descriptor class.  UNIX files and socket abstraction.
    Written by <a href="mailto:tiggr@es.ele.tue.nl">Pieter J. Schoenmakers</a>

    Copyright &copy; 1995, 1996 Pieter J. Schoenmakers.
    All rights reserved.

    This file is part of TOM.  TOM is distributed under the terms of the
    TOM License, a copy of which can be found in the TOM distribution; see
    the file LICENSE.

    <id>$Id: Descriptor.t,v 1.1 1996/07/10 19:05:45 tiggr Exp $</id>
    </copyright>

implementation class
Descriptor: State, Conditions

end;

implementation instance
Descriptor
{
  <doc> The file descriptor.  This will be -1 if we're not actively open.
      </doc>
  public int descriptor;
}

<doc> Close this descriptor.  If it succeeds, every read, write, or other
    operation afterwards will certainly fail.  If it fails, this may not
    be the case.  </doc>
void
  close
{
  [stdio close descriptor];

  descriptor = -1
}

redefine void
  dealloc
{
  if (descriptor != -1)
    bind ((stream-error, nil))
      [self close]
}

redefine id
  init
{
  = [self init -1]
}

<doc> Designated initializer: Initialize with {fd} as the {descriptor}.
    </doc>
protected id
  init int fd
{
  descriptor = fd;

  = self
}

end;
