<copyright> Extension class.
    Written by <a href="mailto:tiggr@es.ele.tue.nl">Pieter J. Schoenmakers</a>

    Copyright &copy; 1996 Pieter J. Schoenmakers.
    All rights reserved.

    This file is part of TOM.  TOM is distributed under the terms of the
    TOM License, a copy of which can be found in the TOM distribution; see
    the file LICENSE.

    <id>$Id: Extension.t,v 1.1 1996/08/20 16:07:57 tiggr Exp $</id>  </copyright>

implementation class
Extension: State, Conditions
{
  <doc> All extensions, here to be protected against gc.  </doc>
  static MutableArray extensions;
}

<doc> Designated allocator.  Do not use {alloc} or plain {new}.  </doc>
instance (id)
  new pointer p
{
  if (!extensions)
    extensions = [MutableObjectArray new];

  id r = [[self alloc] init p];
  [extensions add r];

  = r
}

end;

implementation instance
Extension
{
  <doc> The runtime structure describing this extension.  </doc>
  pointer rti;
}

<doc> An {Extension} should never be deallocated.  This method raises,
    which is a panic during garbage collection...  </doc>
redefine void
  dealloc
{
  [[Condition for self class program-condition
	      message "dealloc considered harmful"] raise]
}

<doc> Return {YES} if this extension provides an implementation for the
    selector {sel}.  </doc>
extern boolean
  implements selector sel;

<doc> Designated initializer.  </doc>
protected id
  init pointer r
{
  rti = r;

  = self
}

<doc> Return the class object to which this extension belongs.  </doc>
extern class (State)
  meta;

<doc> Return the name of this extension.  </doc>
extern String
  name;

redefine OutputStream
  write OutputStream s
{
  s = [super write s];

  = [s print (" name=", [self name], " class=", [self meta])]
}

/******************** perform ********************/

<doc> The equivalent of {perform with} where the method invoked is defined
    by this extension instead of the receiving object.  Obviously, the
    {object} should actually have this extension as on of its extensions,
    i.e. [object isKindOf [self meta]] should be a precondition (and a
    postcondition too, but we're not interested after the fact).  </doc>
extern dynamic
  perform selector sel
       on All object
     with dynamic arguments;

extern dynamic
  perform selector sel
       on All object
	: Array arguments = nil;

end;
