<copyright> Miscellaneous abstract states.
    Written by <a href="mailto:tiggr@es.ele.tue.nl">Pieter J. Schoenmakers</a>

    Copyright &copy; 1996 Pieter J. Schoenmakers.
    All rights reserved.

    This file is part of TOM.  TOM is distributed under the terms of the
    TOM License, a copy of which can be found in the TOM distribution; see
    the file LICENSE.

    <id>$Id: HashTable.t,v 1.7 1996/09/08 14:47:51 tiggr Exp $</id>
    </copyright>

/******************** HashTable ********************/

implementation class HashTable: State

end;

implementation instance HashTable
{
  <doc> The number of keys.  </doc>
  public int length;

  <doc> The number of buckets.  </doc>
  int num_buckets;

  <doc> A pointer to the buckets.  </doc>
  pointer buckets;
}

<doc> Grow the hashtable, doubling its {num_buckets}.  If upon entry
    {num_buckets} is 0, it will become some small constant.  </doc>
private extern void
  resize;

<doc> For the enumerator which previously was at the {element} in the
    {bucket}, return the next element and bucket, prepended by whether there
    is a next and the key object in the bucket element returned.  </doc>
extern (boolean, Any, int, pointer)
  nextKey (int, pointer) (bucket, element);

/********** garbage collection **********/

<doc> Free the data structures created by this hashtable.  </doc>
redefine extern void
  dealloc;

<doc> Mark the keys in this hashtable.  </doc>
redefine extern void
  gc_mark_elements;

end;

/******************** EqHashTable ********************/

<doc> An {EqHashTable} is a {HashTable} which hashes its key on its
    address (instead of sending a {hash} message) and which uses pointer
    equality to test object equality (instead of sending an {equal}
    message).  </doc>
implementation class
EqHashTable: HashTable

end;

implementation instance EqHashTable

<doc> Resizing an {EqHashTable} is different from resizing a normal
    {HashTable} since resizing involves rehashing.  </doc>
redefine private extern void
  resize;

end;
