<copyright> Invocations.
    Written by <a href="mailto:tiggr@es.ele.tue.nl">Pieter J. Schoenmakers</a>

    Copyright &copy; 1996 Pieter J. Schoenmakers.
    All rights reserved.

    This file is part of TOM.  TOM is distributed under the terms of the
    TOM License, a copy of which can be found in the TOM distribution; see
    the file LICENSE.

    <id>$Id: Invocation.t,v 1.3 1996/06/23 09:52:37 tiggr Exp $</id>
    </copyright>

// Somehow, curryable invocations seem like a good idea, but I do not yet
// know how to offer this functionality.
// Mon Jun  3 15:29:02 1996, tiggr@tom.es.ele.tue.nl
//
// Methods like `fireWithArguments' and `fireWithReceiver' seem like a
// good idea.
// Sat Jun 22 22:18:37 1996, tiggr@tricky.es.ele.tue.nl

implementation class
Invocation: State

end;

implementation instance
Invocation
{
  <doc> The object to which the message is to be sent.  </doc>
  public Any target;

  <doc> The selector of the message.  It is public, through the {selector}
      message.  </doc>
  selector sel;

  <doc> Iff not {nil}, the result of the invocation.  </doc>
  InvocationResult result;
}

redefine extern void
  dealloc;

<doc> Perform the invocation.  If fired repeatedly, the invocation will be
    performed repeatedly.  </doc>
extern InvocationResult
  fire;

<doc> If the invocation has been fired at least once, return the (most
    recent) result.  Otherwise, fire and return the result.  </doc>
InvocationResult
  result
{
  = !result ? [self fire] : result
}

<doc> Return this invocation's selector.  </doc>
selector
  selector
{
  = sel
}

end;
