<copyright> Set and MutableSet classes.
    Written by <a href="mailto:tiggr@es.ele.tue.nl">Pieter J. Schoenmakers</a>

    Copyright &copy; 1996 Pieter J. Schoenmakers.
    All rights reserved.

    This file is part of TOM.  TOM is distributed under the terms of the
    TOM License, a copy of which can be found in the TOM distribution; see
    the file LICENSE.

    <id>$Id: Set.t,v 1.10 1996/09/02 15:53:15 tiggr Exp $</id>
    </copyright>

/******************** Set ********************/

implementation class
Set: HashTable, Keyed

end;

implementation instance
Set

/********** Enumerable **********/

Enumerator
  enumerator
{
  = [SetEnumerator with self]
}

id
  initWithEnumerator Enumerator e
{
  //
  [self unimplemented cmd];

  = self
}

/********** Keyed **********/

<doc> Return the {key} if present, or {nil} otherwise.  </doc>
extern Any
  at All key;

end;

/******************** MutableSet ********************/

implementation class
MutableSet: Set, MutableKeyed, Container

end;

implementation instance
MutableSet

/********** MutableKeyed **********/

extern void
  add All object;

extern void
  remove All object;

/********** Container **********/

redefine extern void
  gc_container_mark_elements;

end;

/******************** SetEnumerator ********************/

implementation class
SetEnumerator: State, Enumerator

instance (id)
  with Set set
{
  = [[self alloc] init set]
}

end;

implementation instance
SetEnumerator
{
  <doc> The set we're enumerating.  </doc>
  Set set;

  <doc> The bucket to visit next.  </doc>
  int bucket;

  <doc> Sneaky pointer into the {set}'s data structure pointing to the last
      bucket element we visited.  </doc>
  pointer element;
}

id
  init Set s
{
  set = s;

  = self
}

/********** Enumerator **********/

(boolean, Any)
  next
{
  boolean b;
  Any object;

  (b, object, bucket, element) = [set nextKey (bucket, element)];

  = (b, object)
}

end;
