<copyright> State class.
    Written by <a href="mailto:tiggr@es.ele.tue.nl">Pieter J. Schoenmakers</a>

    Copyright &copy; 1995, 1996 Pieter J. Schoenmakers.
    All rights reserved.

    This file is part of TOM.  TOM is distributed under the terms of the
    TOM License, a copy of which can be found in the TOM distribution; see
    the file LICENSE.

    <id>$Id: State.t,v 1.38 1996/09/05 15:00:10 tiggr Exp $</id>  </copyright>

implementation class
State: instance (All)
{
  <doc> Our class.  The `State' class is an instance of the State
      meta-class.  The same is true for every other class.  </doc>
  class (class (State)) isa;

  <doc> Information used, in cunning ways, by the runtime.  </doc>
  private int asi;
}

<doc> Return a newly created instance of the receiving class.  All values,
    apart from the {isa} will have been initialized to their default
    value.  </doc>
extern instance (id)
  alloc;

<doc> Return {TRUE}, since we're a class object.  </doc.
boolean
  classp
{
  = YES
}

<doc> Return the class of the receiving object, i.e. the value of {isa}.
    </doc>
class (id)
  kind
{
  = isa
}

<doc> Return the name of this class.  </doc>
extern ByteString
  name;

<doc> Return a newly created and initialized instance of the receiving
    class.  </doc>
instance (id)
  new
{
  = [[self alloc] init]
}

<doc> Write a description of this class object to the stream {s}.  </doc>
OutputStream
  write OutputStream s
{
  = [[[s print "#<class "] print [self name]] print ">"]
}

end;

implementation instance
State: instance (All)
{
  <doc> Our class.  </doc>
  class (id) isa;

  <doc> Information used, in cunning ways, by the runtime.  </doc>
  private int asi;
}

<doc> Return {FALSE}, as we're an instance, and not a class.  </doc>
boolean
  classp
{
  = NO
}

<doc> Designated initializer.  Does nothing.  </doc>
id
  init
{
  = self
}

<doc> Return the class of the receiving object.  </doc>
class (id)
  kind
{
  = isa
}

<doc> Write the class and address of the receiving object to the stream
    {s}.  </doc>
OutputStream
  write OutputStream s
{
  = [[[[[s print "#<instance "] print [self address]] print " "]
      print [isa name]] print ">"]
}

/******************** garbage collection ********************/

<doc> Invoked by the garbage collector when an object has become garbage.
    Some important notes apply to this method:

    Do not message any other objects from within this method as they might
    have become garbage too.

    Since class objects can not become garbage, it is safe to message
    class objects.

    When overriding this method, it is not necessary to invoke {State}'s
    implementation.  </doc>
void
  dealloc
{
  void
}

<doc> This method is invoked by the garbage collector for instances which
    employ pointer typed instance variables, to have the receiving object
    mark the elements it references.  The default implementation does
    nothing.  </doc>
private void
  gc_mark_elements
{
  void
}

end;
