<copyright> Everything about coding.
    Written by <a href="mailto:tiggr@es.ele.tue.nl">Pieter J. Schoenmakers</a>

    Copyright &copy; 1996 Pieter J. Schoenmakers.
    All rights reserved.

    This file is part of TOM.  TOM is distributed under the terms of the
    TOM License, a copy of which can be found in the TOM distribution; see
    the file LICENSE.

    <id>$Id: coding.t,v 1.2 1996/08/20 15:59:28 tiggr Exp $</id>
    </copyright>

/* Multiple inheritance causes some interesting problems with coding:

	If B and C are subclasses of A, and D is a subclass of both B and
	C, then the A part of D must only be encoded once.

   Other coding problems, not caused by multiple inheritance:

	It must function in the context of multithreaded DO.

	Forward references and conditional archive membership.  */

/******************** State (Coding) ********************/

implementation class
State extension Coding
{
  <doc> The version of this class.  </doc>
  int version;
}

end;

implementation instance
State extension Coding

void
  encodeUsingCoder Encoder coder
{
  [coder startEncoding self]
}

Any
  replacementForPortCoder PortEncoder coder
{
  = self
}

Any
  replacementForStreamCoder StreamEncoder coder
{
  = self
}

end;

/******************** Coder ********************/

implementation class
Coder: State
{
  <doc> The version of the coding scheme used.  </doc>
  static public int coding_version;
}

end;

implementation instance
Coder

end;

/******************** Encoder ********************/

implementation class
Encoder: Coder

end;

implementation instance
Encoder
{
  <doc> The object we're currently encoding.  </doc>
  All current_object;
}

<doc> The core object encoding method.  </doc>
void
  encode All object
{
  [self unimplemented cmd]
}

boolean
  startEncoding All object
{
  [self unimplemented cmd];

  = NO
}

end;

/******************** Decoder ********************/

implementation class
Decoder: Coder

end;

implementation instance
Decoder

end;
