<copyright> TOO DescriptorSet.
    Written by <a href="mailto:tiggr@es.ele.tue.nl">Pieter J. Schoenmakers</a>

    Copyright (C) 1996 Pieter J. Schoenmakers.
    All rights reserved.

    This file is part of TOM.  TOM is distributed under the terms of the
    TOM License, a copy of which can be found in the TOM distribution; see
    the file LICENSE.

    <id>$Id: DescriptorSet.t,v 1.1 1996/07/10 22:35:57 tiggr Exp $</id>
    </copyright>

implementation class
DescriptorSet: State

end;

implementation instance
DescriptorSet
{
  <doc> The bitset of descriptors usable to select(2).  </doc>
  pointer set;

  <doc> One beyond the highest descriptor that can be put in the set.  </doc>
  int cap;

  <doc> One beyond the highest descriptor present in the set.  </doc>
  int beyond_last;

  <doc> The number of present descriptors in the set.  </doc>
  int num;

  <doc> The array of {Descriptor} objects.  </doc>
  MutableObjectArray descriptors;

  <doc> The array of {DescriptorDelegate} objects.  </doc>
  MutableObjectArray delegates;
}

redefine extern void
  dealloc;

redefine id
  init
{
  descriptors = [MutableObjectArray new];
  delegates = [MutableObjectArray new];

  = self
}

void
  readEvent int d
{
  DescriptorReadDelegate delegate = delegates[d];

  [delegate readEventOnDescriptor descriptors[d]]
}

extern void
  remove Descriptor descriptor;

extern void
  set DescriptorDelegate delegate
   at Descriptor descriptor;

(pointer, int)
  vitals
{
  = (set, beyond_last)
}

void
  writeEvent int d
{
  DescriptorWriteDelegate delegate = delegates[d];

  [delegate writeEventOnDescriptor descriptors[d]]
}

end;
