<copyright> TOO RunLoop.
    Written by <a href="mailto:tiggr@es.ele.tue.nl">Pieter J. Schoenmakers</a>

    Copyright (C) 1996 Pieter J. Schoenmakers.
    All rights reserved.

    This file is part of TOM.  TOM is distributed under the terms of the
    TOM License, a copy of which can be found in the TOM distribution; see
    the file LICENSE.

    <id>$Id: RunLoop.t,v 1.2 1996/07/11 16:49:12 tiggr Exp $</id>
    </copyright>

implementation class
RunLoop: State
{
  // This should be thread-local...
  // Wed Jul 10 22:46:02 1996, tiggr@tricky.es.ele.tue.nl
  <doc> The global, shared, run loop.  </doc>
  static instance (id) shared_run_loop;
}

instance (id)
  currentRunLoop
{
  if (!shared_run_loop)
    shared_run_loop = [self new];
  = shared_run_loop
}

end;

implementation instance
RunLoop
{
  // I know abou the exception set, but I also know I forgot what it can
  // be used for, added to that the fact that I have never used it...
  // Wed Jul 10 22:45:05 1996, tiggr@tricky.es.ele.tue.nl
  <doc> The read and write sets.  </doc>
  DescriptorSet read_set, write_set;

  <doc> Iff {TRUE}, one of the sets was changed.  </doc>
  boolean changed;
}

void
  addDescriptorForRead Descriptor descriptor
	      delegate DescriptorReadDelegate delegate
{
  changed = YES;
  read_set[descriptor] = delegate
}

void
  addDescriptorForWrite Descriptor descriptor
	       delegate DescriptorWriteDelegate delegate
{
  changed = YES;
  write_set[descriptor] = delegate
}

redefine id
  init
{
  read_set = [DescriptorSet new];
  write_set = [DescriptorSet new];

  = self
}

void
  removeReadDescriptor Descriptor descriptor
{
  changed = YES;
  [read_set remove descriptor]
}

void
  removeWriteDescriptor Descriptor descriptor
{
  changed = YES;
  [write_set remove descriptor]
}

extern void
  run;

end;
