/*
   Written by Pieter J. Schoenmakers <tiggr@es.ele.tue.nl>

   Copyright (C) 1996 Pieter J. Schoenmakers.
   All rights reserved.

   This file is part of TOM.  TOM is distributed under the terms of the
   TOM License, a copy of which can be found in the TOM distribution; see
   the file LICENSE.

   $Id: bag.c,v 1.2 1996/05/29 21:19:19 tiggr Exp $  */

#include <stdio.h>
#include <string.h>
#include "trt.h"
#include <tom/tom-r.h>
#include "keyed.h"

tom_int
i_tom_Bag_i_at_r (tom_object self, selector cmd, tom_object key)
{
  bag_elt *be = (void *) bucket_elt_find (self, key);

  return be ? be->count : 0;
}

tom_object
i_tom_Bag_r_at_r (tom_object self, selector cmd, tom_object key)
{
  bag_elt *be = (void *) bucket_elt_find (self, key);

  return be ? be->c.key : 0;
}

void
i_tom_MutableBag_v_add_r_count_i (tom_object self, selector cmd,
				  tom_object object, tom_int count)
{
  struct bag_elt *be;

  if (count <= 0)
    {
      if (!count)
	return;
      ABORT ();
    }

  be = (void *) bucket_elt_find_create (self, object, sizeof (*be));
  be->count += count;
}
