/*
   Written by Pieter J. Schoenmakers <tiggr@es.ele.tue.nl>

   Copyright (C) 1996 Pieter J. Schoenmakers.
   All rights reserved.

   This file is part of TOM.  TOM is distributed under the terms of the
   TOM License, a copy of which can be found in the TOM distribution; see
   the file LICENSE.

   $Id: dictionary.c,v 1.5 1996/06/26 00:25:56 tiggr Exp $  */

#include <string.h>
#include "trt.h"
#include <tom/tom-r.h>
#include "keyed.h"

tom_object
i_tom_Dictionary_r_at_r (tom_object self, selector cmd, tom_object key)
{
  dict_elt *be = (void *) bucket_elt_find (self, key);

  return be ? be->value : 0;
}

void
i_tom_Dictionary_v_gc_mark_elements (tom_object self, selector cmd)
{
  struct _es_i_tom_HashTable *ht = trt_ext_address (self, _ei_i_tom_HashTable);
  dict_elt *be, **buckets = ht->buckets;
  tom_int i, n = ht->num_buckets;

  for (i = 0; i < n; i++)
    for (be = buckets[i]; be; be = be->c.next)
      {
	if (TGC_COLOUR (be->c.key->asi) == TGC_WHITE)
	  trt_make_gray (be->c.key);
	if (be->value && TGC_COLOUR (be->value->asi) == TGC_WHITE)
	  trt_make_gray (be->value);
      }
}

void
i_tom_MutableDictionary_v_remove_r (tom_object self, selector cmd,
				    tom_object key)
{
  bucket_elt_remove (self, key);
}

void
i_tom_MutableDictionary_v_set_r_at_r (tom_object self, selector cmd,
				      tom_object value, tom_object key)
{
  dict_elt *be = (void *) bucket_elt_find_create (self, key, sizeof (*be));

  be->value = value;
}

tom_byte
i_tom_Dictionary__orip__nextValue__ip_ (tom_object self, selector cmd,
					int bucket, struct bucket_elt *be,
					tom_object *object, tom_int *nbucket,
					struct bucket_elt **nbe)
{
  tom_byte b = TRT_SEND ((byte_imp), self,
			 SEL (_orip__nextKey__ip_),
			 bucket, be, object, nbucket, nbe);

  if (b)
    *object = ((struct dict_elt *) (*nbe))->value;

  /* XXX Is this correct?
     Wed Jun 26 01:30:15 1996, tiggr@tricky.es.ele.tue.nl  */
  return b;
}
