/*
   Written by Pieter J. Schoenmakers <tiggr@es.ele.tue.nl>

   Copyright (C) 1996 Pieter J. Schoenmakers.
   All rights reserved.

   This file is part of TOM.  TOM is distributed under the terms of the
   TOM License, a copy of which can be found in the TOM distribution; see
   the file LICENSE.

   $Id: lookup.c,v 1.8 1996/06/28 16:51:09 tiggr Exp $  */

#include "trt.h"

void_imp
trt_lookup (tom_object self, selector cmd)
{
  unsigned int sid = cmd->sel_id;

#if defined (DEBUG) || defined (ALWAYS_CHECK_NIL_RECEIVER)
  extern void_imp trt_lookup_nil (selector);

  if (!self)
    return trt_lookup_nil (cmd);
#endif

  return (self->isa->info.mdt
	  ->b[sid / TRT_BUCKET_SIZE]->m[sid % TRT_BUCKET_SIZE]);
}

void_imp
trt_lookup_super (struct trt_class *super, selector cmd)
{
  unsigned int sid = cmd->sel_id;

  return super->info.mdt->b[sid / TRT_BUCKET_SIZE]->m[sid % TRT_BUCKET_SIZE];
}
